
#property indicator_separate_window
#property indicator_level2 0.75
#property indicator_level3 0.45
#property indicator_level4 0.15

extern double gamma = 0.8;
extern int CountBars = 950;
double gd_88 = 0.0;
double gd_96 = 0.0;
double gd_104 = 0.0;
double gd_112 = 0.0;
double gd_120 = 0.0;
double gd_128 = 0.0;
double gd_136 = 0.0;
double gd_144 = 0.0;
double gd_152 = 0.0;
double gd_160 = 0.0;
double gd_168 = 0.0;
double g_ibuf_176[];

int init() {
   SetIndexBuffer(0, g_ibuf_176);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
//   if (Time[0] > StrToTime("01.02.2010 23:59")) return (0);
   if (CountBars > Bars) CountBars = Bars;
   SetIndexDrawBegin(0, Bars - CountBars);
   int l_ind_counted_0 = IndicatorCounted();
   for (int li_4 = CountBars - 1; li_4 >= 0; li_4--) {
      gd_120 = gd_88;
      gd_128 = gd_96;
      gd_136 = gd_104;
      gd_144 = gd_112;
      gd_88 = (1 - gamma) * Close[li_4] + gamma * gd_120;
      gd_96 = (-gamma) * gd_88 + gd_120 + gamma * gd_128;
      gd_104 = (-gamma) * gd_96 + gd_128 + gamma * gd_136;
      gd_112 = (-gamma) * gd_104 + gd_136 + gamma * gd_144;
      gd_160 = 0;
      gd_168 = 0;
      if (gd_88 >= gd_96) gd_160 = gd_88 - gd_96;
      else gd_168 = gd_96 - gd_88;
      if (gd_96 >= gd_104) gd_160 = gd_160 + gd_96 - gd_104;
      else gd_168 = gd_168 + gd_104 - gd_96;
      if (gd_104 >= gd_112) gd_160 = gd_160 + gd_104 - gd_112;
      else gd_168 = gd_168 + gd_112 - gd_104;
      if (gd_160 + gd_168 != 0.0) gd_152 = gd_160 / (gd_160 + gd_168);
      g_ibuf_176[li_4] = gd_152;
   }
   return (0);
}
