
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 FireBrick

extern int Periyod = 7;
extern double Level = 0.0004;
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];

int init() {
   IndicatorBuffers(5);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 1);
   SetIndexDrawBegin(0, Level);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 2.0);
   if (!SetIndexBuffer(0, g_ibuf_88) && !SetIndexBuffer(1, g_ibuf_92) && !SetIndexBuffer(2, g_ibuf_96) && !SetIndexBuffer(3, g_ibuf_100) && !SetIndexBuffer(4, g_ibuf_104)) Print("cannot set indicator buffers!");
   IndicatorShortName("pfd_vol(" + Periyod + "," + Level + ")");
   return (0);
}

int start() {
//   if (Time[0] > StrToTime("01.02.2010 23:59")) return (0);
   if (Symbol() == "USDJPY") Level = 0.04;
   if (Symbol() == "EURJPY") Level = 0.04;
   if (Symbol() == "GBPJPY") Level = 0.04;
   int li_0 = IndicatorCounted();
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   int li_4 = Bars - li_0;
   for (int li_8 = 0; li_8 < li_4; li_8++) {
      g_ibuf_96[li_8] = iStdDev(NULL, 0, Periyod, 1, MODE_SMA, PRICE_CLOSE, li_8) - Level;
      if (g_ibuf_96[li_8] > 0.0) {
         g_ibuf_88[li_8] = g_ibuf_96[li_8];
         g_ibuf_92[li_8] = 0;
      } else {
         if (g_ibuf_96[li_8] < 0.0) {
            g_ibuf_92[li_8] = g_ibuf_96[li_8];
            g_ibuf_88[li_8] = 0;
         } else {
            g_ibuf_88[li_8] = 0;
            g_ibuf_92[li_8] = 0;
         }
      }
   }
   return (0);
}
